Bug 830123 - RFE: add some documentation about GRUB2 on EFI systems
RFE: add some documentation about GRUB2 on EFI systems
Status: CLOSED CURRENTRELEASE
Product: Fedora Documentation
Classification: Fedora
Component: system-administrator's-guide (Show other bugs)
devel
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Stephen Wadeley
Christopher Antila
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-08 05:54 EDT by Jan Vcelak
Modified: 2016-05-19 15:33 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-05-19 15:33:49 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jan Vcelak 2012-06-08 05:54:00 EDT
The documentation for GRUB2 with EFI is very poor. I spent a few hours trying to figure out how it actually works. And it took me very long time until I configured the system to boot autonomously without my help.

It would be nice, if some basic information about grub2-efi can be included in the documentation for Fedora 18. I was told, that grub-efi is used in F17 because there are still some problems with grub2-efi.

I tried with grub2-efi-2.0-0.36.beta6.fc17.x86_64, and some stuff will probably change in future, but here are some points we could include:

- As EFI systems use EFI System Partition (ESP) to store bootloader images, the GRUB2 installation means copying the boot image on the partition. No MBR modification and similar is required. In case of Fedora, ESP parition is mounted to /boot/efi.

- You need to set up grub image to be used when booting. EFI systems provide some configuration tool when starting the system. This can be also achieved using "bootmgr" tool (not sure) and probably grub2-efi-install can do that (not sure even more). By default, the image location is "/boot/efi/EFI/fedora/grubx64.efi" and therefore the boot option in EFI boot manager is "fedora".

- Functional GRUB EFI image is provided in grub2-efi package. And it just works. grub2-efi-install probably selects different modules when building the image. I was able to boot with this image, but without grub menu. I do not know if I did something wrong, or if the tool should be invoked with some special options.

- Nice way to determine the expected location of grub.conf is to take a look at the target of "/etc/grub2-efi.cfg" symlink.

- To regenerate the GRUB2 configuration file invoke grub2-mkconfig like this:
grub2-mkconfig -o $(readlink -f /etc/grub2-efi.cfg)


Not sure, who can provide more information. I know that Mathew Garrett works on EFI and he probably knows a lot about the low level stuff. And Peter Jones (grub2 maintainer) as well. I'm adding them to CC, maybe they will have some other useful information.

I'm willing to help if needed. :)
Comment 2 Jaromir Hradilek 2013-07-09 08:27:30 EDT
Thank you very much for taking the time to report this issue, Jan.
Comment 3 Pete Travis 2015-05-18 10:59:29 EDT
Stephen has been working on this area.
Comment 4 Stephen Wadeley 2015-05-18 12:00:44 EDT
Hello

I am sorry I was not aware of this bug before.

 For the current state see the "Working with the GRUB 2 Boot Loader" chapter here: http://docs.fedoraproject.org/en-US/Fedora/21/html/System_Administrators_Guide/ch-Working_with_the_GRUB_2_Boot_Loader.html

there are few fixes in the master docs repo and some more coming in tie for Fedora 22

Thank you
Comment 6 Stephen Wadeley 2015-12-11 03:35:08 EST
 Hello Jan

Have you had time to review the docs as per comment 5?

Here is the new link:
https://docs.fedoraproject.org/en-US/Fedora/23/html/System_Administrators_Guide/ch-Working_with_the_GRUB_2_Boot_Loader.html

Note You need to log in before you can comment on or make changes to this bug.